"""A class that represents the internal Graphnode used for dealing with .vcg's  

Some longer documentation will be put here in the future
"""
import string, vcg_parse
class vcgGraphNode:
  """A class that represents the internal Graphnode used for dealing with .vcg's
  
  Some longer documentation will be put here in the future
  
  """  
  def __init__(self, name_A, attributes_A = { 'color':'white' }):
    self.name = name_A
    self.attributes = {}
    self.visited = 0
    for k, v in attributes_A.items():
      self.attributes[ k ] = v
    
  def set_attribute( self, attrib_name, attrib_string ):
    self.attributes[ attrib_name ] = attrib_string
    
  def get_attribute( self, attrib_name ):
    return self.attributes[ attrib_name ]
    
  def add_attributes( self, attributes ):
    for k, v in attributes.items():
      self.attributes[ k ] = v
  
  def make_vcg_output( self ):
    output = 'node:\t{\n\ttitle: "' + self.name + '"\n\t'
    for k, v in self.attributes.items():
      output = output + k + ": " + v + "\n"
    output = output + '}\n'
    return output
    
  def parse_vcg_output( self, vcg_string ):
#    print "--->"+ vcg_string 
    # first off, retrieve the label and remove it (only multi-line attribute there is
    self.attributes[ "label" ] = vcg_parse.vcg_get_enclosed_attribute( vcg_string, "label" )
#    print self.attributes[ "label" ]
    if self.attributes[ "label" ] == 0:
      self.attributes[ "label" ] = '" "'
#      print "NO label found, weird !"
    else:
      vcg_string = string.replace( vcg_string, 'label: '+ self.attributes[ "label" ], "" )
    tokens = string.split( vcg_string )
    for k in tokens:
      if k[-1] == ':':
        # an attribute -- find the value
        i = 0;
        while i != len( tokens ):
          if (tokens[ i ] == k) and (tokens[ i ] != "title:" ) and (tokens[ i ] != "node:") and (tokens[ i ] != "label:"):
#            print "Setting attribute "+k+" to value "+ tokens[i + 1]+"\n"
            self.attributes[ k[0:-1] ] = tokens[ i + 1 ]
          i = 1+i

  GDL_colors = {
    '00': 'white',      # 255 255 255
    '16': 'lightblue',  # 128 128 255
    '01': 'blue',       # 0   0 255
    '17': 'lightred',   # 255 128 128
    '02': 'red',        # 255   0   0
    '18': 'lightgreen', # 128 255 128
    '03': 'green',      # 0 255   0
    '19': 'lightyellow',# 255 255 128
    '04': 'yellow',     # 255 255   0
    '20': 'lightmagenta',# 255 128 255
    '05': 'magenta',    # 255   0 255
    '21': 'lightcyan',  # 128 255 255
    '06': 'cyan',       # 0 255 255
    '22': 'lilac',      # 238 130 238
    '07': 'darkgrey',   # 85  85  85
    '23': 'turquoise',  # 64 224 208
    '08': 'darkblue',   # 0   0 128
    '24': 'aquamarine', # 127 255 212
    '09': 'darkred',    # 128   0   0
    '25': 'khaki',      # 240 230 140
    '10': 'darkgreen',  # 0 128   0
    '26': 'purple',     # 160  32 240
    '11': 'darkyellow', # 128 128   0
    '27': 'yellowgreen',# 154 205  50
    '12': 'darkmagenta',# 128   0 128
    '28': 'pink',       # 255 192 203
    '13': 'darkcyan',   # 0 128 128
    '29': 'orange',     # 255 165   0
    '14': 'gold',       # 255 215   0
    '30': 'orchid',     # 218 112 214
    '15': 'lightgrey',  # 170 170 170
    '31': 'black',      # 0   0   0
    # IDA Palette
    '32': '#000000',
    '33': '#0000ff',
    '34': '#0000ff',
    '35': '#808080',
    '36': '#808080',
    '37': '#000080',
    '38': '#000080',
    '39': '#0000ff',
    '40': '#0000ff',
    '41': '#000080',
    '42': '#008000',
    '43': '#00ff00',
    '44': '#008000',
    '45': '#ff8000',
    '46': '#008000',
    '47': '#8080ff',
    '48': '#ff0000',
    '49': '#808000',
    '50': '#010101',
    '51': '#c0c0c0',
    '52': '#0000ff',
    '53': '#0000ff',
    '54': '#0000ff',
    '55': '#808080',
    '56': '#8080ff',
    '57': '#008000',
    '58': '#000080',
    '59': '#0000ff',
    '60': '#800080',
    '61': '#008000',
    '62': '#008000',
    '63': '#008040',
    '64': '#000080',
    '65': '#000080',
    '66': '#ff00ff',
    '67': '#808000',
    '68': '#000080',
    '69': '#0000ff',
    '70': '#000080',
    '71': '#0000ff',
    '72': '#000000',
    '73': '#ffffff',
    '74': '#c0c0c0',
    '75': '#00ffff',
    '76': '#000000',
    '77': '#800000',
    '78': '#808080',
    '79': '#808000',
    '80': '#ff00ff',
    '81': '#000000',
    '82': '#0000ff',
    '83': '#000000',
    }

  def getColor(self, index):
    return self.GDL_colors[index]
    
  def GDLTextToHTML(self, str):
      answer = ''
      word = ''
      color = ''
      i = 0
      while i < len(str):
          c = str[i]
          if c == '\f':
              if word:
                  if color:
                      answer += '<font color=%s>%s</font>' % (self.getColor(color), word)
                  else:
                      answer += word
                  word = ''
              if str[i+1].isdigit():
                  color = str[i+1:i+3]
                  i += 2
              else:
                  i += 1
          elif c == ' ':
              word += '&amp;nbsp;'
          else:
              word += c
          i += 1

      if color:
          answer += '<font color=%s>%s</font>' % (color, word)
      else:
          answer += word

      return answer
    
  def labelAsHTML(self):
      label = self.attributes['label']
      label = label.replace('"',"").splitlines()
      label = map(lambda each:self.GDLTextToHTML(each), label)
      html = ''
      html += '<br>\n'.join(label)
      return html
    
  def make_daVinci_output( self, graph ):
    davinci_string = 'l("node_'+self.name+'", n("", [ a("OBJECT","'+ self.attributes[ "label" ][1:-1] + '")], [ '
    # now add all the links
    linkset = graph.Get_Downlinks_From( self.name )
    if linkset != 0:
      for k in linkset:
        davinci_string += k.make_daVinci_output()
        davinci_string += ','
    davinci_string2 = davinci_string[:-1] + ']))\n'
    return davinci_string2
    
  def make_GML_output( self, graph ):
    gml_output = ' node [\n'
    gml_output += '  id "%s"\n' % self.name
    gml_output += '  label "%s"\n' % self.name
    gml_output += '  graphics [\n'
    gml_output += '   type "rectangle"\n'
    gml_output += '   fill "#CCCCFF"\n'
    gml_output += '   outline "#000000"\n'
    gml_output += '  ]\n'
    gml_output += '  LabelGraphics [\n'
    gml_output += '   fontSize 11\n'
    gml_output += '   fontName "Courier"\n'
    gml_output += '   text "<html>%s</html>\n"' % self.labelAsHTML()
    gml_output += '  ]\n'
    gml_output += ' ]\n'
    return gml_output

  def make_GraphML_output(self, graph):
    graphml_output = ''\